Index: svn/src/cpu/amd/model_fxx/init_cpus.c
===================================================================
--- svn.orig/src/cpu/amd/model_fxx/init_cpus.c
+++ svn/src/cpu/amd/model_fxx/init_cpus.c
@@ -16,39 +16,23 @@
 
 static inline void print_initcpu8 (const char *strval, unsigned val)
 {
-#if CONFIG_USE_PRINTK_IN_CAR
         printk_debug("%s%02x\r\n", strval, val);
-#else
-        print_debug(strval); print_debug_hex8(val); print_debug("\r\n");
-#endif
 }
 
 static inline void print_initcpu8_nocr (const char *strval, unsigned val)
 {
-#if CONFIG_USE_PRINTK_IN_CAR
         printk_debug("%s%02x", strval, val);
-#else
-        print_debug(strval); print_debug_hex8(val);
-#endif
 }
 
 
 static inline void print_initcpu16 (const char *strval, unsigned val)
 {
-#if CONFIG_USE_PRINTK_IN_CAR
         printk_debug("%s%04x\r\n", strval, val);
-#else
-        print_debug(strval); print_debug_hex16(val); print_debug("\r\n");
-#endif
 }
 
 static inline void print_initcpu(const char *strval, unsigned val)
 {
-#if CONFIG_USE_PRINTK_IN_CAR
         printk_debug("%s%08x\r\n", strval, val);
-#else
-        print_debug(strval); print_debug_hex32(val); print_debug("\r\n");
-#endif
 }
 
 typedef void (*process_ap_t)(unsigned apicid, void *gp);
@@ -171,14 +155,7 @@ static void init_fidvid_ap(unsigned bsp_
 
 static inline __attribute__((always_inline)) void print_apicid_nodeid_coreid(unsigned apicid, struct node_core_id id, const char *str)
 {
-	#if CONFIG_USE_PRINTK_IN_CAR
                 printk_debug("%s --- {  APICID = %02x NODEID = %02x COREID = %02x} ---\r\n", str, apicid, id.nodeid, id.coreid);
-	#else
-		print_debug(str);
-        	print_debug(" ---- {APICID = "); print_debug_hex8(apicid);
-		print_debug(" NODEID = "), print_debug_hex8(id.nodeid); print_debug(" COREID = "), print_debug_hex8(id.coreid);
-	        print_debug("} --- \r\n");
-        #endif
 }
 
 
Index: svn/src/northbridge/amd/amdk8/debug.c
===================================================================
--- svn.orig/src/northbridge/amd/amdk8/debug.c
+++ svn/src/northbridge/amd/amdk8/debug.c
@@ -10,27 +10,14 @@
 static inline void print_debug_addr(const char *str, void *val)
 {
 #if CACHE_AS_RAM_ADDRESS_DEBUG == 1
-	#if CONFIG_USE_PRINTK_IN_CAR
-		printk_debug("------Address debug: %s%x------\r\n", str, val);
-	#else
-		print_debug ("------Address debug: "); print_debug(str); print_debug_hex32(val); print_debug("------\r\n");
-	#endif
+		printk_debug("------Address debug: %s%x------\n", str, val);
 #endif
 }
 
 #if 1
 static void print_debug_pci_dev(unsigned dev)
 {
-#if CONFIG_USE_PRINTK_IN_CAR
 	printk_debug("PCI: %02x:%02x.%02x", (dev>>20) & 0xff, (dev>>15) & 0x1f, (dev>>12) & 0x7);
-#else
-	print_debug("PCI: ");
-	print_debug_hex8((dev >> 20) & 0xff);
-	print_debug_char(':');
-	print_debug_hex8((dev >> 15) & 0x1f);
-	print_debug_char('.');
-	print_debug_hex8((dev >> 12) & 7);
-#endif
 }
 
 static void print_pci_devices(void)
@@ -47,13 +34,7 @@ static void print_pci_devices(void)
 			continue;
 		}
 		print_debug_pci_dev(dev);
-#if CONFIG_USE_PRINTK_IN_CAR
-		printk_debug(" %04x:%04x\r\n", (id & 0xffff), (id>>16));
-#else
-		print_debug(" ");
-		print_debug_hex32(id);
-		print_debug("\r\n");
-#endif
+		printk_debug(" %04x:%04x\n", (id & 0xffff), (id>>16));
 		if(((dev>>12) & 0x07) == 0) {
 			uint8_t hdr_type;
 			hdr_type = pci_read_config8(dev, PCI_HEADER_TYPE);
@@ -72,23 +53,12 @@ static void dump_pci_device(unsigned dev
 	for(i = 0; i < 256; i++) {
 		unsigned char val;
 		if ((i & 0x0f) == 0) {
-#if CONFIG_USE_PRINTK_IN_CAR
-			printk_debug("\r\n%02x:",i);
-#else
-			print_debug("\r\n");
-			print_debug_hex8(i);
-			print_debug_char(':');
-#endif
+			printk_debug("\n%02x:",i);
 		}
 		val = pci_read_config8(dev, i);
-#if CONFIG_USE_PRINTK_IN_CAR
 		printk_debug(" %02x", val);
-#else
-		print_debug_char(' ');
-		print_debug_hex8(val);
-#endif
 	}
-	print_debug("\r\n");
+	print_debug("\n");
 }
 
 #if CONFIG_K8_REV_F_SUPPORT == 1
@@ -102,25 +72,15 @@ static void dump_pci_device_index_wait(u
 	for(i = 0; i < 0x40; i++) {
 		uint32_t val;
 		int j;
-#if CONFIG_USE_PRINTK_IN_CAR
-		printk_debug("\r\n%02x:",i);
-#else
-		print_debug("\r\n");
-		print_debug_hex8(i);
-		print_debug_char(':');
-#endif
+		printk_debug("\n%02x:",i);
 		val = pci_read_config32_index_wait(dev, index_reg, i);
 		for(j=0;j<4;j++) {
-#if CONFIG_USE_PRINTK_IN_CAR
 			printk_debug(" %02x", val & 0xff);
-#else
-			print_debug_char(' '); print_debug_hex8(val&0xff);
-#endif
 			val >>= 8;
 		}
 
 	}
-	print_debug("\r\n");
+	print_debug("\n");
 }
 #endif
 
@@ -182,98 +142,57 @@ static void dump_pci_devices_on_bus(unsi
 static void dump_spd_registers(const struct mem_controller *ctrl)
 {
 	int i;
-	print_debug("\r\n");
+	print_debug("\n");
 	for(i = 0; i < 4; i++) {
 		unsigned device;
 		device = ctrl->channel0[i];
 		if (device) {
 			int j;
-#if CONFIG_USE_PRINTK_IN_CAR
 			printk_debug("dimm: %02x.0: %02x", i, device);
-#else
-			print_debug("dimm: ");
-			print_debug_hex8(i);
-			print_debug(".0: ");
-			print_debug_hex8(device);
-#endif
 			for(j = 0; j < 128; j++) {
 				int status;
 				unsigned char byte;
 				if ((j & 0xf) == 0) {
-#if CONFIG_USE_PRINTK_IN_CAR
-					printk_debug("\r\n%02x: ", j);
-#else
-					print_debug("\r\n");
-					print_debug_hex8(j);
-					print_debug(": ");
-#endif
+					printk_debug("\n%02x: ", j);
 				}
 				status = smbus_read_byte(device, j);
 				if (status < 0) {
 					break;
 				}
 				byte = status & 0xff;
-#if CONFIG_USE_PRINTK_IN_CAR
 				printk_debug("%02x ", byte);
-#else
-				print_debug_hex8(byte);
-				print_debug_char(' ');
-#endif
 			}
-			print_debug("\r\n");
+			print_debug("\n");
 		}
 		device = ctrl->channel1[i];
 		if (device) {
 			int j;
-#if CONFIG_USE_PRINTK_IN_CAR
 			printk_debug("dimm: %02x.1: %02x", i, device);
-#else
-			print_debug("dimm: ");
-			print_debug_hex8(i);
-			print_debug(".1: ");
-			print_debug_hex8(device);
-#endif
 			for(j = 0; j < 128; j++) {
 				int status;
 				unsigned char byte;
 				if ((j & 0xf) == 0) {
-#if CONFIG_USE_PRINTK_IN_CAR
-					printk_debug("\r\n%02x: ", j);
-#else
-					print_debug("\r\n");
-					print_debug_hex8(j);
-					print_debug(": ");
-#endif
+					printk_debug("\n%02x: ", j);
 				}
 				status = smbus_read_byte(device, j);
 				if (status < 0) {
 					break;
 				}
 				byte = status & 0xff;
-#if CONFIG_USE_PRINTK_IN_CAR
 				printk_debug("%02x ", byte);
-#else
-				print_debug_hex8(byte);
-				print_debug_char(' ');
-#endif
 			}
-			print_debug("\r\n");
+			print_debug("\n");
 		}
 	}
 }
 static void dump_smbus_registers(void)
 {
 	unsigned device;
-	print_debug("\r\n");
+	print_debug("\n");
 	for(device = 1; device < 0x80; device++) {
 		int j;
 		if( smbus_read_byte(device, 0) < 0 ) continue;
-#if CONFIG_USE_PRINTK_IN_CAR
 		printk_debug("smbus: %02x", device);
-#else
-		print_debug("smbus: ");
-		print_debug_hex8(device);
-#endif
 		for(j = 0; j < 256; j++) {
 			int status;
 			unsigned char byte;
@@ -282,23 +201,12 @@ static void dump_smbus_registers(void)
 				break;
 			}
 			if ((j & 0xf) == 0) {
-#if CONFIG_USE_PRINTK_IN_CAR
-				printk_debug("\r\n%02x: ",j);
-#else
-				print_debug("\r\n");
-				print_debug_hex8(j);
-				print_debug(": ");
-#endif
+				printk_debug("\n%02x: ",j);
 			}
 			byte = status & 0xff;
-#if CONFIG_USE_PRINTK_IN_CAR
 			printk_debug("%02x ", byte);
-#else
-			print_debug_hex8(byte);
-			print_debug_char(' ');
-#endif
 		}
-		print_debug("\r\n");
+		print_debug("\n");
 	}
 }
 #endif
@@ -308,31 +216,16 @@ static void dump_io_resources(unsigned p
 
 	int i;
 	udelay(2000);
-#if CONFIG_USE_PRINTK_IN_CAR
-	printk_debug("%04x:\r\n", port);
-#else
-	print_debug_hex16(port);
-	print_debug(":\r\n");
-#endif
+	printk_debug("%04x:\n", port);
 	for(i=0;i<256;i++) {
 		uint8_t val;
 		if ((i & 0x0f) == 0) {
-#if CONFIG_USE_PRINTK_IN_CAR
 			printk_debug("%02x:", i);
-#else
-			print_debug_hex8(i);
-			print_debug_char(':');
-#endif
 		}
 		val = inb(port);
-#if CONFIG_USE_PRINTK_IN_CAR
 		printk_debug(" %02x",val);
-#else
-		print_debug_char(' ');
-		print_debug_hex8(val);
-#endif
 		if ((i & 0x0f) == 0x0f) {
-			print_debug("\r\n");
+			print_debug("\n");
 		}
 		port++;
 	}
@@ -344,21 +237,10 @@ static void dump_mem(unsigned start, uns
 	print_debug("dump_mem:");
 	for(i=start;i<end;i++) {
 		if((i & 0xf)==0) {
-#if CONFIG_USE_PRINTK_IN_CAR
-			printk_debug("\r\n%08x:", i);
-#else
-			print_debug("\r\n");
-			print_debug_hex32(i);
-			print_debug(":");
-#endif
+			printk_debug("\n%08x:", i);
 		}
-#if CONFIG_USE_PRINTK_IN_CAR
 		printk_debug(" %02x", (unsigned char)*((unsigned char *)i));
-#else
-		print_debug(" ");
-	     	print_debug_hex8((unsigned char)*((unsigned char *)i));
-#endif
 	}
-	print_debug("\r\n");
+	print_debug("\n");
  }
 #endif
Index: svn/src/cpu/amd/model_fxx/fidvid.c
===================================================================
--- svn.orig/src/cpu/amd/model_fxx/fidvid.c
+++ svn/src/cpu/amd/model_fxx/fidvid.c
@@ -15,33 +15,21 @@
 static inline void print_debug_fv(const char *str, unsigned val)
 {
 #if K8_SET_FIDVID_DEBUG == 1
-	#if CONFIG_USE_PRINTK_IN_CAR
 		printk_debug("%s%x\r\n", str, val);
-	#else
-		print_debug(str); print_debug_hex32(val); print_debug("\r\n");
-	#endif
 #endif
 }
 
 static inline void print_debug_fv_8(const char *str, unsigned val)
 {
 #if K8_SET_FIDVID_DEBUG == 1
-	#if CONFIG_USE_PRINTK_IN_CAR
 		printk_debug("%s%02x\r\n", str, val);
-	#else
-		print_debug(str); print_debug_hex8(val); print_debug("\r\n");
-	#endif
 #endif
 }
 
 static inline void print_debug_fv_64(const char *str, unsigned val, unsigned val2)
 {
 #if K8_SET_FIDVID_DEBUG == 1
-	#if CONFIG_USE_PRINTK_IN_CAR
 		printk_debug("%s%x%x\r\n", str, val, val2);
-	#else
-		print_debug(str); print_debug_hex32(val); print_debug_hex32(val2); print_debug("\r\n");
-	#endif
 #endif
 }
 
@@ -143,11 +131,7 @@ static u32 set_fidvid(unsigned apicid, u
 	apicidx = lapicid();
 
 	if (apicid != apicidx) {
-#if CONFIG_USE_PRINTK_IN_CAR
 		printk_err("wrong apicid, we want change %x, but it is %x\r\n", apicid, apicidx);
-#else
-		print_err("wrong apicid, we want change "); print_err_hex8(apicid); print_err(" but it is "); print_err_hex8(apicidx); print_err("\r\n");
-#endif
 		return fidvid;
 	}
 
Index: svn/src/northbridge/amd/amdk8/coherent_ht.c
===================================================================
--- svn.orig/src/northbridge/amd/amdk8/coherent_ht.c
+++ svn/src/northbridge/amd/amdk8/coherent_ht.c
@@ -111,13 +111,7 @@
 
 static inline void print_linkn (const char *strval, uint8_t byteval)
 {
-#if 1
-#if CONFIG_USE_PRINTK_IN_CAR
 	printk_debug("%s%02x\r\n", strval, byteval);
-#else
-	print_debug(strval); print_debug_hex8(byteval); print_debug("\r\n");
-#endif
-#endif
 }
 
 static void disable_probes(void)
@@ -1502,12 +1496,7 @@ static unsigned setup_smp(void)
 		nodes = setup_smp8();
 #endif
 
-#if CONFIG_USE_PRINTK_IN_CAR
 	printk_debug("%02x nodes initialized.\r\n", nodes);
-#else
-	print_debug_hex8(nodes);
-	print_debug(" nodes initialized.\r\n");
-#endif
 
 	return nodes;
 }
Index: svn/src/northbridge/amd/amdk8/incoherent_ht.c
===================================================================
--- svn.orig/src/northbridge/amd/amdk8/incoherent_ht.c
+++ svn/src/northbridge/amd/amdk8/incoherent_ht.c
@@ -28,10 +28,6 @@
 	#define K8_ALLOCATE_MMIO_RANGE 0
 #endif
 
-#if CONFIG_USE_PRINTK_IN_CAR == 0
-#error This file needs CONFIG_USE_PRINTK_IN_CAR
-#endif
-
 static inline void print_linkn_in (const char *strval, uint8_t byteval)
 {
 	printk_debug("%s%02x\r\n", strval, byteval);
Index: svn/src/northbridge/amd/amdk8/raminit_f.c
===================================================================
--- svn.orig/src/northbridge/amd/amdk8/raminit_f.c
+++ svn/src/northbridge/amd/amdk8/raminit_f.c
@@ -34,11 +34,6 @@
 #define QRANK_DIMM_SUPPORT 0
 #endif
 
-#if CONFIG_USE_PRINTK_IN_CAR
-#else
-#error This file needs CONFIG_USE_PRINTK_IN_CAR
-#endif
-
 #define RAM_TIMING_DEBUG 0
 
 #if RAM_TIMING_DEBUG == 1
Index: svn/src/northbridge/amd/amdk8/raminit_f_dqs.c
===================================================================
--- svn.orig/src/northbridge/amd/amdk8/raminit_f_dqs.c
+++ svn/src/northbridge/amd/amdk8/raminit_f_dqs.c
@@ -21,11 +21,6 @@
 //0: mean no debug info
 #define DQS_TRAIN_DEBUG 0
 
-#if CONFIG_USE_PRINTK_IN_CAR
-#else
-#error This file needs CONFIG_USE_PRINTK_IN_CAR
-#endif
-
 static inline void print_debug_dqs(const char *str, unsigned val, unsigned level)
 {
 #if DQS_TRAIN_DEBUG > 0
Index: svn/src/northbridge/amd/amdk8/setup_resource_map.c
===================================================================
--- svn.orig/src/northbridge/amd/amdk8/setup_resource_map.c
+++ svn/src/northbridge/amd/amdk8/setup_resource_map.c
@@ -12,14 +12,7 @@ static void setup_resource_map_offset(co
 		unsigned where;
 		unsigned long reg;
 #if 0
-	#if CONFIG_USE_PRINTK_IN_CAR
 		prink_debug("%08x <- %08x\r\n", register_values[i] +  offset_pci_dev, register_values[i+2]);
-	#else
-		print_debug_hex32(register_values[i] + offset_pci_dev);
-		print_debug(" <-");
-		print_debug_hex32(register_values[i+2]);
-		print_debug("\r\n");
-	#endif
 #endif
 		dev = (register_values[i] & ~0xfff) + offset_pci_dev;
 		where = register_values[i] & 0xfff;
@@ -56,27 +49,12 @@ static void setup_resource_map_x_offset(
 #endif
 	for(i = 0; i < max; i += 4) {
 #if RES_DEBUG
-	#if CONFIG_USE_PRINTK_IN_CAR
 		printk_debug("%04x: %02x %08x <- & %08x | %08x\r\n",
 			i>>2, register_values[i],
 			register_values[i+1] + ( (register_values[i]==RES_PCI_IO) ? offset_pci_dev : 0),
 			register_values[i+2],
 			register_values[i+3] + ( ( (register_values[i] & RES_PORT_IO_32) == RES_PORT_IO_32) ? offset_io_base : 0)
 			);
-	#else
-		print_debug_hex16(i>>2);
-		print_debug(": ");
-		print_debug_hex8(register_values[i]);
-		print_debug(" ");
-		print_debug_hex32(register_values[i+1] + ( (register_values[i]==RES_PCI_IO) ? offset_pci_dev : 0) );
-		print_debug(" <- & ");
-		print_debug_hex32(register_values[i+2]);
-		print_debug(" | ");
-		print_debug_hex32(register_values[i+3] +
-			(((register_values[i] & RES_PORT_IO_32) == RES_PORT_IO_32) ? offset_io_base : 0)
-			);
-		print_debug("\r\n");
-	#endif
 #endif
 		switch (register_values[i]) {
 		case RES_PCI_IO: //PCI
@@ -151,21 +129,8 @@ static void setup_resource_map_x(const u
 #endif
 	for(i = 0; i < max; i += 4) {
 #if RES_DEBUG
-	#if CONFIG_USE_PRINTK_IN_CAR
 		printk_debug("%04x: %02x %08x <- & %08x | %08x\r\n",
 			i/4, register_values[i],register_values[i+1], register_values[i+2], register_values[i+3]);
-	#else
-		print_debug_hex16(i/4);
-		print_debug(": ");
-		print_debug_hex8(register_values[i]);
-		print_debug(" ");
-		print_debug_hex32(register_values[i+1]);
-		print_debug(" <- & ");
-		print_debug_hex32(register_values[i+2]);
-		print_debug(" | ");
-		print_debug_hex32(register_values[i+3]);
-		print_debug("\r\n");
-	#endif
 #endif
 		switch (register_values[i]) {
 		case RES_PCI_IO: //PCI
Index: svn/src/cpu/amd/car/post_cache_as_ram.c
===================================================================
--- svn.orig/src/cpu/amd/car/post_cache_as_ram.c
+++ svn/src/cpu/amd/car/post_cache_as_ram.c
@@ -7,11 +7,7 @@
 
 static inline void print_debug_pcar(const char *strval, uint32_t val)
 {
-#if CONFIG_USE_PRINTK_IN_CAR
         printk_debug("%s%08x\r\n", strval, val);
-#else
-        print_debug(strval); print_debug_hex32(val); print_debug("\r\n");
-#endif
 }
 
 static void inline __attribute__((always_inline))  memcopy(void *dest, const void *src, unsigned long bytes)