Index: svn/src/cpu/amd/car/post_cache_as_ram.c
===================================================================
--- svn.orig/src/cpu/amd/car/post_cache_as_ram.c
+++ svn/src/cpu/amd/car/post_cache_as_ram.c
@@ -107,9 +107,6 @@ static void post_cache_as_ram(void)
 
 //	dump_mem((CONFIG_RAMTOP) - 0x8000, (CONFIG_RAMTOP) - 0x7c00);
 
-#ifndef CONFIG_MEM_TRAIN_SEQ
-#define CONFIG_MEM_TRAIN_SEQ 0
-#endif
         set_sysinfo_in_ram(1); // So other core0 could start to train mem
 
 #if CONFIG_MEM_TRAIN_SEQ == 1
Index: svn/src/cpu/amd/model_10xxx/init_cpus.c
===================================================================
--- svn.orig/src/cpu/amd/model_10xxx/init_cpus.c
+++ svn/src/cpu/amd/model_10xxx/init_cpus.c
@@ -306,11 +306,6 @@ static void STOP_CAR_AND_CPU()
 	stop_this_cpu();
 }
 
-
-#ifndef CONFIG_MEM_TRAIN_SEQ
-#define CONFIG_MEM_TRAIN_SEQ 0
-#endif
-
 #if RAMINIT_SYSINFO == 1
 static u32 init_cpus(u32 cpu_init_detectedx ,struct sys_info *sysinfo)
 #else
Index: svn/src/cpu/amd/model_fxx/init_cpus.c
===================================================================
--- svn.orig/src/cpu/amd/model_fxx/init_cpus.c
+++ svn/src/cpu/amd/model_fxx/init_cpus.c
@@ -238,11 +238,6 @@ static void STOP_CAR_AND_CPU(void)
 	stop_this_cpu(); // inline, it will stop all cores except node0/core0 the bsp ....
 }
 
-#ifndef CONFIG_MEM_TRAIN_SEQ
-#define CONFIG_MEM_TRAIN_SEQ 0
-#endif
-
-
 #if CONFIG_MEM_TRAIN_SEQ == 1
 static inline void train_ram_on_node(unsigned nodeid, unsigned coreid, struct sys_info *sysinfo, unsigned retcall); 
 #endif
Index: svn/src/mainboard/amd/serengeti_cheetah/Kconfig
===================================================================
--- svn.orig/src/mainboard/amd/serengeti_cheetah/Kconfig
+++ svn/src/mainboard/amd/serengeti_cheetah/Kconfig
@@ -14,7 +14,6 @@ config BOARD_AMD_SERENGETI_CHEETAH
 	select HAVE_HARD_RESET
 	select IOAPIC
 	select LIFT_BSP_APIC_ID
-	select MEM_TRAIN_SEQ
 	select AP_CODE_IN_CAR
 	select SB_HT_CHAIN_UNITID_OFFSET_ONLY
 	select WAIT_BEFORE_CPUS_INIT
@@ -81,6 +80,11 @@ config HW_MEM_HOLE_SIZE_AUTO_INC
 	default n
 	depends on BOARD_AMD_SERENGETI_CHEETAH
 
+config MEM_TRAIN_SEQ
+	int
+	default 1
+	depends on BOARD_AMD_SERENGETI_CHEETAH
+
 config SB_HT_CHAIN_ON_BUS0
 	int
 	default 2
Index: svn/src/mainboard/gigabyte/ga_2761gxdk/Kconfig
===================================================================
--- svn.orig/src/mainboard/gigabyte/ga_2761gxdk/Kconfig
+++ svn/src/mainboard/gigabyte/ga_2761gxdk/Kconfig
@@ -12,7 +12,6 @@ config BOARD_GIGABYTE_GA_2761GXDK
 	select HAVE_HARD_RESET
 	select IOAPIC
 	select LIFT_BSP_APIC_ID
-	select MEM_TRAIN_SEQ
 	select SB_HT_CHAIN_UNITID_OFFSET_ONLY
 	select K8_REV_F_SUPPORT
 	select BOARD_ROMSIZE_KB_512
@@ -42,6 +41,11 @@ config APIC_ID_OFFSET
 	default 16
 	depends on BOARD_GIGABYTE_GA_2761GXDK
 
+config MEM_TRAIN_SEQ
+	int
+	default 1
+	depends on BOARD_GIGABYTE_GA_2761GXDK
+
 config SB_HT_CHAIN_ON_BUS0
 	int
 	default 2
Index: svn/src/mainboard/gigabyte/m57sli/Kconfig
===================================================================
--- svn.orig/src/mainboard/gigabyte/m57sli/Kconfig
+++ svn/src/mainboard/gigabyte/m57sli/Kconfig
@@ -14,7 +14,6 @@ config BOARD_GIGABYTE_M57SLI
 	select HAVE_HARD_RESET
 	select IOAPIC
 	select LIFT_BSP_APIC_ID
-	select MEM_TRAIN_SEQ
 	select SB_HT_CHAIN_UNITID_OFFSET_ONLY
 	select HAVE_ACPI_TABLES
 	select K8_REV_F_SUPPORT
@@ -45,6 +44,11 @@ config APIC_ID_OFFSET
 	default 16
 	depends on BOARD_GIGABYTE_M57SLI
 
+config MEM_TRAIN_SEQ
+	int
+	default 1
+	depends on BOARD_GIGABYTE_M57SLI
+
 config SB_HT_CHAIN_ON_BUS0
 	int
 	default 2
Index: svn/src/mainboard/msi/ms7135/Kconfig
===================================================================
--- svn.orig/src/mainboard/msi/ms7135/Kconfig
+++ svn/src/mainboard/msi/ms7135/Kconfig
@@ -22,6 +22,11 @@ config APIC_ID_OFFSET
 	default 0x10
 	depends on BOARD_MSI_MS7135
 
+config MEM_TRAIN_SEQ
+	int
+	default 1
+	depends on BOARD_MSI_MS7135
+
 config SB_HT_CHAIN_ON_BUS0
 	int
 	default 2
@@ -52,11 +57,6 @@ config HW_MEM_HOLE_SIZEK
 	default 0x100000
 	depends on BOARD_MSI_MS7135
 
-config MEM_TRAIN_SEQ
-	bool
-	default n
-	depends on BOARD_MSI_MS7135
-
 config MAX_CPUS
 	int
 	default 2
@@ -67,11 +67,6 @@ config MAX_PHYSICAL_CPUS
 	default 1
 	depends on BOARD_MSI_MS7135
 
-config MEM_TRAIN_SEQ
-	bool
-	default n
-	depends on BOARD_MSI_MS7135
-
 config HW_MEM_HOLE_SIZE_AUTO_INC
 	bool
 	default n
Index: svn/src/mainboard/msi/ms7260/Kconfig
===================================================================
--- svn.orig/src/mainboard/msi/ms7260/Kconfig
+++ svn/src/mainboard/msi/ms7260/Kconfig
@@ -13,7 +13,6 @@ config BOARD_MSI_MS7260
 	select HAVE_HARD_RESET
 	select IOAPIC
 	select LIFT_BSP_APIC_ID
-	select MEM_TRAIN_SEQ
 	select SB_HT_CHAIN_UNITID_OFFSET_ONLY
 	select K8_REV_F_SUPPORT
 	select BOARD_ROMSIZE_KB_512
@@ -43,6 +42,11 @@ config APIC_ID_OFFSET
 	default 16
 	depends on BOARD_MSI_MS7260
 
+config MEM_TRAIN_SEQ
+	int
+	default 1
+	depends on BOARD_MSI_MS7260
+
 config SB_HT_CHAIN_ON_BUS0
 	int
 	default 2
Index: svn/src/mainboard/msi/ms9282/Kconfig
===================================================================
--- svn.orig/src/mainboard/msi/ms9282/Kconfig
+++ svn/src/mainboard/msi/ms9282/Kconfig
@@ -12,7 +12,6 @@ config BOARD_MSI_MS9282
 	select USE_DCACHE_RAM
 	select HAVE_HARD_RESET
 	select IOAPIC
-	select MEM_TRAIN_SEQ
 	select SB_HT_CHAIN_UNITID_OFFSET_ONLY
 	select K8_REV_F_SUPPORT
 	select BOARD_ROMSIZE_KB_512
Index: svn/src/mainboard/nvidia/l1_2pvv/Kconfig
===================================================================
--- svn.orig/src/mainboard/nvidia/l1_2pvv/Kconfig
+++ svn/src/mainboard/nvidia/l1_2pvv/Kconfig
@@ -13,7 +13,6 @@ config BOARD_NVIDIA_L1_2PVV
 	select HAVE_HARD_RESET
 	select IOAPIC
 	select LIFT_BSP_APIC_ID
-	select MEM_TRAIN_SEQ
 	select SB_HT_CHAIN_UNITID_OFFSET_ONLY
 	select K8_REV_F_SUPPORT
 	select BOARD_ROMSIZE_KB_512
@@ -43,6 +42,11 @@ config APIC_ID_OFFSET
 	default 16
 	depends on BOARD_NVIDIA_L1_2PVV
 
+config MEM_TRAIN_SEQ
+	int
+	default 1
+	depends on BOARD_NVIDIA_L1_2PVV
+
 config SB_HT_CHAIN_ON_BUS0
 	int
 	default 2
Index: svn/src/mainboard/technexion/tim8690/Kconfig
===================================================================
--- svn.orig/src/mainboard/technexion/tim8690/Kconfig
+++ svn/src/mainboard/technexion/tim8690/Kconfig
@@ -13,7 +13,6 @@ config BOARD_TECHNEXION_TIM8690
 	select USE_DCACHE_RAM
 	select HAVE_HARD_RESET
 	select IOAPIC
-	select MEM_TRAIN_SEQ
 	select SB_HT_CHAIN_UNITID_OFFSET_ONLY
 	select WAIT_BEFORE_CPUS_INIT
 	select HAVE_ACPI_TABLES
Index: svn/src/mainboard/tyan/s2880/Kconfig
===================================================================
--- svn.orig/src/mainboard/tyan/s2880/Kconfig
+++ svn/src/mainboard/tyan/s2880/Kconfig
@@ -51,11 +51,6 @@ config HW_MEM_HOLE_SIZEK
 	default 0x100000
 	depends on BOARD_TYAN_S2880
 
-config MEM_TRAIN_SEQ
-	bool
-	default n
-	depends on BOARD_TYAN_S2880
-
 config MAX_CPUS
 	int
 	default 4
@@ -66,11 +61,6 @@ config MAX_PHYSICAL_CPUS
 	default 2
 	depends on BOARD_TYAN_S2880
 
-config MEM_TRAIN_SEQ
-	bool
-	default n
-	depends on BOARD_TYAN_S2880
-
 config HW_MEM_HOLE_SIZE_AUTO_INC
 	bool
 	default n
Index: svn/src/mainboard/tyan/s2881/Kconfig
===================================================================
--- svn.orig/src/mainboard/tyan/s2881/Kconfig
+++ svn/src/mainboard/tyan/s2881/Kconfig
@@ -51,11 +51,6 @@ config HW_MEM_HOLE_SIZEK
 	default 0x100000
 	depends on BOARD_TYAN_S2881
 
-config MEM_TRAIN_SEQ
-	bool
-	default n
-	depends on BOARD_TYAN_S2881
-
 config MAX_CPUS
 	int
 	default 4
@@ -66,11 +61,6 @@ config MAX_PHYSICAL_CPUS
 	default 2
 	depends on BOARD_TYAN_S2881
 
-config MEM_TRAIN_SEQ
-	bool
-	default n
-	depends on BOARD_TYAN_S2881
-
 config HW_MEM_HOLE_SIZE_AUTO_INC
 	bool
 	default n
Index: svn/src/mainboard/tyan/s2882/Kconfig
===================================================================
--- svn.orig/src/mainboard/tyan/s2882/Kconfig
+++ svn/src/mainboard/tyan/s2882/Kconfig
@@ -51,11 +51,6 @@ config HW_MEM_HOLE_SIZEK
 	default 0x100000
 	depends on BOARD_TYAN_S2882
 
-config MEM_TRAIN_SEQ
-	bool
-	default n
-	depends on BOARD_TYAN_S2882
-
 config MAX_CPUS
 	int
 	default 4
@@ -66,11 +61,6 @@ config MAX_PHYSICAL_CPUS
 	default 2
 	depends on BOARD_TYAN_S2882
 
-config MEM_TRAIN_SEQ
-	bool
-	default n
-	depends on BOARD_TYAN_S2882
-
 config HW_MEM_HOLE_SIZE_AUTO_INC
 	bool
 	default n
Index: svn/src/mainboard/tyan/s2885/Kconfig
===================================================================
--- svn.orig/src/mainboard/tyan/s2885/Kconfig
+++ svn/src/mainboard/tyan/s2885/Kconfig
@@ -51,11 +51,6 @@ config HW_MEM_HOLE_SIZEK
 	default 0x100000
 	depends on BOARD_TYAN_S2885
 
-config MEM_TRAIN_SEQ
-	bool
-	default n
-	depends on BOARD_TYAN_S2885
-
 config MAX_CPUS
 	int
 	default 4
@@ -66,11 +61,6 @@ config MAX_PHYSICAL_CPUS
 	default 2
 	depends on BOARD_TYAN_S2885
 
-config MEM_TRAIN_SEQ
-	bool
-	default n
-	depends on BOARD_TYAN_S2885
-
 config HW_MEM_HOLE_SIZE_AUTO_INC
 	bool
 	default n
Index: svn/src/mainboard/tyan/s2891/Kconfig
===================================================================
--- svn.orig/src/mainboard/tyan/s2891/Kconfig
+++ svn/src/mainboard/tyan/s2891/Kconfig
@@ -53,11 +53,6 @@ config HW_MEM_HOLE_SIZEK
 	default 0x100000
 	depends on BOARD_TYAN_S2891
 
-config MEM_TRAIN_SEQ
-	bool
-	default n
-	depends on BOARD_TYAN_S2891
-
 config MAX_CPUS
 	int
 	default 4
@@ -68,11 +63,6 @@ config MAX_PHYSICAL_CPUS
 	default 2
 	depends on BOARD_TYAN_S2891
 
-config MEM_TRAIN_SEQ
-	bool
-	default n
-	depends on BOARD_TYAN_S2891
-
 config HW_MEM_HOLE_SIZE_AUTO_INC
 	bool
 	default n
Index: svn/src/mainboard/tyan/s2892/Kconfig
===================================================================
--- svn.orig/src/mainboard/tyan/s2892/Kconfig
+++ svn/src/mainboard/tyan/s2892/Kconfig
@@ -53,11 +53,6 @@ config HW_MEM_HOLE_SIZEK
 	default 0x100000
 	depends on BOARD_TYAN_S2892
 
-config MEM_TRAIN_SEQ
-	bool
-	default n
-	depends on BOARD_TYAN_S2892
-
 config MAX_CPUS
 	int
 	default 4
@@ -68,11 +63,6 @@ config MAX_PHYSICAL_CPUS
 	default 2
 	depends on BOARD_TYAN_S2892
 
-config MEM_TRAIN_SEQ
-	bool
-	default n
-	depends on BOARD_TYAN_S2892
-
 config HW_MEM_HOLE_SIZE_AUTO_INC
 	bool
 	default n
Index: svn/src/mainboard/tyan/s2895/Kconfig
===================================================================
--- svn.orig/src/mainboard/tyan/s2895/Kconfig
+++ svn/src/mainboard/tyan/s2895/Kconfig
@@ -53,11 +53,6 @@ config HW_MEM_HOLE_SIZEK
 	default 0x100000
 	depends on BOARD_TYAN_S2895
 
-config MEM_TRAIN_SEQ
-	bool
-	default n
-	depends on BOARD_TYAN_S2895
-
 config MAX_CPUS
 	int
 	default 4
@@ -68,11 +63,6 @@ config MAX_PHYSICAL_CPUS
 	default 2
 	depends on BOARD_TYAN_S2895
 
-config MEM_TRAIN_SEQ
-	bool
-	default n
-	depends on BOARD_TYAN_S2895
-
 config HW_MEM_HOLE_SIZE_AUTO_INC
 	bool
 	default n
Index: svn/src/mainboard/tyan/s2912/Kconfig
===================================================================
--- svn.orig/src/mainboard/tyan/s2912/Kconfig
+++ svn/src/mainboard/tyan/s2912/Kconfig
@@ -13,7 +13,6 @@ config BOARD_TYAN_S2912
 	select HAVE_HARD_RESET
 	select IOAPIC
 	select LIFT_BSP_APIC_ID
-	select MEM_TRAIN_SEQ
 	select SB_HT_CHAIN_UNITID_OFFSET_ONLY
 	select K8_REV_F_SUPPORT
 	select BOARD_ROMSIZE_KB_512
@@ -43,6 +42,11 @@ config APIC_ID_OFFSET
 	default 16
 	depends on BOARD_TYAN_S2912
 
+config MEM_TRAIN_SEQ
+	int
+	default 1
+	depends on BOARD_TYAN_S2912
+
 config SB_HT_CHAIN_ON_BUS0
 	int
 	default 2
Index: svn/src/mainboard/tyan/s2912_fam10/Kconfig
===================================================================
--- svn.orig/src/mainboard/tyan/s2912_fam10/Kconfig
+++ svn/src/mainboard/tyan/s2912_fam10/Kconfig
@@ -13,7 +13,6 @@ config BOARD_TYAN_S2912_FAM10
 	select HAVE_HARD_RESET
 	select IOAPIC
 	select LIFT_BSP_APIC_ID
-	select MEM_TRAIN_SEQ
 	select SB_HT_CHAIN_UNITID_OFFSET_ONLY
 	select BOARD_ROMSIZE_KB_1024
 	select ENABLE_APIC_EXT_ID
@@ -44,6 +43,11 @@ config APIC_ID_OFFSET
 	default 16
 	depends on BOARD_TYAN_S2912_FAM10
 
+config MEM_TRAIN_SEQ
+	int
+	default 2
+	depends on BOARD_TYAN_S2912_FAM10
+
 config SB_HT_CHAIN_ON_BUS0
 	int
 	default 2
Index: svn/src/mainboard/amd/serengeti_cheetah_fam10/Kconfig
===================================================================
--- svn.orig/src/mainboard/amd/serengeti_cheetah_fam10/Kconfig
+++ svn/src/mainboard/amd/serengeti_cheetah_fam10/Kconfig
@@ -67,6 +67,11 @@ config HW_MEM_HOLE_SIZE_AUTO_INC
 	default n
 	depends on BOARD_AMD_SERENGETI_CHEETAH_FAM10
 
+config MEM_TRAIN_SEQ
+	int
+	default 2
+	depends on BOARD_AMD_SERENGETI_CHEETAH_FAM10
+
 config SB_HT_CHAIN_ON_BUS0
 	int
 	default 2
Index: svn/src/mainboard/asus/a8n_e/Kconfig
===================================================================
--- svn.orig/src/mainboard/asus/a8n_e/Kconfig
+++ svn/src/mainboard/asus/a8n_e/Kconfig
@@ -34,6 +34,11 @@ config APIC_ID_OFFSET
 	default 0x10
 	depends on BOARD_ASUS_A8N_E
 
+config MEM_TRAIN_SEQ
+	int
+	default 2
+	depends on BOARD_ASUS_A8N_E
+
 config SB_HT_CHAIN_ON_BUS0
 	int
 	default 2
Index: svn/src/mainboard/supermicro/h8dme/Kconfig
===================================================================
--- svn.orig/src/mainboard/supermicro/h8dme/Kconfig
+++ svn/src/mainboard/supermicro/h8dme/Kconfig
@@ -41,6 +41,11 @@ config APIC_ID_OFFSET
 	default 0x10
 	depends on BOARD_SUPERMICRO_H8DME
 
+config MEM_TRAIN_SEQ
+	int
+	default 1
+	depends on BOARD_SUPERMICRO_H8DME
+
 config SB_HT_CHAIN_ON_BUS0
 	int
 	default 2
Index: svn/src/mainboard/supermicro/h8dmr/Kconfig
===================================================================
--- svn.orig/src/mainboard/supermicro/h8dmr/Kconfig
+++ svn/src/mainboard/supermicro/h8dmr/Kconfig
@@ -40,6 +40,11 @@ config APIC_ID_OFFSET
 	default 0x10
 	depends on BOARD_SUPERMICRO_H8DMR
 
+config MEM_TRAIN_SEQ
+	int
+	default 1
+	depends on BOARD_SUPERMICRO_H8DMR
+
 config SB_HT_CHAIN_ON_BUS0
 	int
 	default 2
Index: svn/src/mainboard/supermicro/h8dmr_fam10/Kconfig
===================================================================
--- svn.orig/src/mainboard/supermicro/h8dmr_fam10/Kconfig
+++ svn/src/mainboard/supermicro/h8dmr_fam10/Kconfig
@@ -41,6 +41,11 @@ config APIC_ID_OFFSET
 	default 0x10
 	depends on BOARD_SUPERMICRO_H8DMR_FAM10
 
+config MEM_TRAIN_SEQ
+	int
+	default 1
+	depends on BOARD_SUPERMICRO_H8DMR_FAM10
+
 config SB_HT_CHAIN_ON_BUS0
 	int
 	default 2